//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}


int main()
{
  //    
  //    "..........abcdef.........."
  vector<char> source(10,'.');
  for (int c='a'; c<='f'; c++) {
      source.push_back(c);
  }
  source.insert(source.end(),10,'.');
  PRINT_ELEMENTS(source," :\n");

  //          'a'
  vector<char> c1(source.begin(),source.end());
  copy (c1.begin()+10, c1.begin()+16,  //  
        c1.begin()+7);                 //  
  PRINT_ELEMENTS(c1," c1:\n");

  //          'f'
  vector<char> c2(source.begin(),source.end());
  copy_backward (c2.begin()+10, c2.begin()+16,  // 
                 c2.begin()+19);                // 
  PRINT_ELEMENTS(c2,"  c2:\n");


  getch();
  return 0;
}

//---------------------------------------------------------------------------